/*
  divisors.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <libgen.h>
#include <cmath>
#include <boost/lexical_cast.hpp>
#include "prime_util.hh"

void cout_divisors(const isprime_bit_table_class::huge_uint_type n)
{
  isprime_bit_table_class::huge_uint_type d(1), sqrt_n;

  sqrt_n = sqrt(n);
  for (; d<=sqrt_n; ++d)
    if (n%d == 0) {
      std::cout << d << "\t";
      if (d != n/d) std::cout << n/d << "\t";
    }
  std::cout << std::endl;
}

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " number [...]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;

  if (argc < 2) return usage(std::cerr, argc, argv);
  for (a=1; a<argc; ++a)
    cout_divisors(boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[a]));
  
  return 0;
}
