/*
  factorize.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <sstream>
#include <string>
#include <libgen.h>
#include <boost/lexical_cast.hpp>
#include "prime_util.hh"

void cout_factorize(isprime_bit_table_class::huge_uint_type n)
{
  isprime_bit_table_class::huge_uint_type f(2), c;
  isprime_bit_table_class isprime_bit_table;

  std::cout << n << "\t";
  if (n == 1) std::cout << 1 << "^" << 0 << "\t";
  for (; f <= n; f = isprime_bit_table.nextprime(f)) {
    c = 0;
    while (n % f == 0) {
      ++c;
      n /= f;
    }
    if (c > 0) std::cout << f << "^" << c << "\t";
    if (!(f < isprime_bit_table.get_upper())) throw std::length_error("isprime_bit_table: over the length");
  }
  std::cout << std::endl;
}

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [number ...]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  isprime_bit_table_class::huge_uint_type n;

  if (argc < 2) return usage(std::cerr, argc, argv);
  for (a=1; a<argc; ++a) {
    n = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[a]);
    cout_factorize(n);
  }
  return 0;
}
