/*
  integer_valued_polynomial_progression.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <vector>
#include <libgen.h>
#include <boost/lexical_cast.hpp>
#include "prime_util.hh"

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [-c coefficient ...] [-k number]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  isprime_bit_table_class::huge_uint_type n, k(10), i;
  std::vector<isprime_bit_table_class::huge_uint_type> c;

  for (a=1; a<argc; ++a)
    if (std::string(argv[a]) == "-h")
      return usage(std::cout, argc, argv);
    else if (std::string(argv[a]) == "-c" && ++a < argc)
      for (; a<argc; ++a) {
	isprime_bit_table_class::huge_uint_type n;
	try { n = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[a]); }
	catch (...) { --a; break; }
	c.push_back(n);
      }
    else if (std::string(argv[a]) == "-k" && a+1 < argc)
      k = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[++a]);
    else
      break;

  for (i=0; i<k; ++i) {
    n = 0;
    for (size_t j=0; j<c.size(); j++) {
      isprime_bit_table_class::huge_uint_type x;
      x = pow(i, j);
      n += c[j]*x;
    }
    std::cout << n << std::endl;
  }  

  return 0;
}
