/*
  isprime.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <libgen.h>
#include <boost/lexical_cast.hpp>
#include "prime_util.hh"

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [-u upper] [number ...]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  isprime_bit_table_class::huge_uint_type n, u(1000000000);

  for (a=1; a<argc; ++a) {
    if (std::string(argv[a]) == "-h")
      return usage(std::cout, argc, argv);
    else if (std::string(argv[a]) == "-u" && a+1<argc)
      n = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[++a]);
    else
      break;
  }
  if (a < 1) return usage(std::cerr, argc, argv);
  isprime_bit_table_class isprime_bit_table(u);
  for (; a<argc; ++a) {
    n = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[a]);
    if (!(n < isprime_bit_table.get_upper())) throw std::length_error("isprime_bit_table: over the length");
    if (!isprime_bit_table[n])
      return 1;
  }
  return 0;
}
