/*
  lcm.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <libgen.h>
#include <boost/lexical_cast.hpp>
#include <boost/math/common_factor.hpp>
#include "prime_util.hh"

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " number number\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  isprime_bit_table_class::huge_uint_type n[2], lcm;

  if (argc < 3) return usage(std::cerr, argc, argv);
  for (a=1; a<3; ++a)
    n[a-1] = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[a]);

  lcm = boost::math::lcm(n[0], n[1]);
  std::cout << lcm << std::endl;
  
  return 0;
}
