/*
  next_prime.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <libgen.h>
#include <boost/lexical_cast.hpp>
#include "prime_util.hh"

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [number ...]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  isprime_bit_table_class::huge_uint_type n;

  if (argc < 2) return usage(std::cerr, argc, argv);
  isprime_bit_table_class isprime_bit_table;
  for (a=1; a<argc; ++a) {
    n = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[a]);
    if (!(n < isprime_bit_table.get_upper())) throw std::length_error("isprime_bit_table: over the length");
    if (argc > 2) std::cout << n << "\t";
    n = isprime_bit_table.nextprime(n);
    std::cout << n << std::endl;
  }

  return 0;
}
