/*
  prime_polynomial_progression.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <vector>
#include <libgen.h>
#include <boost/lexical_cast.hpp>
#include "prime_util.hh"

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [-l lower] [-u upper] [-c coefficient ...] [-k number]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  isprime_bit_table_class::huge_uint_type n, l(1), u(1000000000), k(17), i;
  std::vector<std::vector<isprime_bit_table_class::huge_uint_type> > c;

  for (a=1; a<argc; ++a)
    if (std::string(argv[a]) == "-h")
      return usage(std::cout, argc, argv);
    else if (std::string(argv[a]) == "-l" && a+1 < argc)
      l = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[++a]);
    else if (std::string(argv[a]) == "-u" && a+1 < argc)
      u = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[++a]);
    else if (std::string(argv[a]) == "-c" && ++a < argc) {
      c.push_back(std::vector<isprime_bit_table_class::huge_uint_type>());
      for (; a<argc; ++a) {
	isprime_bit_table_class::huge_uint_type n;
	try { n = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[a]); }
	catch (...) { --a; break; }
	c[c.size()-1].push_back(n);
      }
    }
    else if (std::string(argv[a]) == "-k" && a+1 < argc)
      k = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[++a]);
    else
      break;

  isprime_bit_table_class isprime_bit_table(u);
  for (; l<u; l = isprime_bit_table.nextprime(l)) {
    for (size_t t=0; t<c.size(); ++t) {
      c[t][0] = l;
      for (i=0; ; ++i) {
	n = 0;
	for (size_t j=0; j<c[t].size(); j++) {
	  isprime_bit_table_class::huge_uint_type x;
	  x = pow(i, j);
	  n += c[t][j]*x;
	}
	if (!(n < isprime_bit_table.get_upper())) throw std::length_error("isprime_bit_table: over the length");
	if (!isprime_bit_table[n]) break;
      }
      if (i>k) {
	std::cout << i << "\t";
	for (size_t j=0; j<c[t].size(); j++) std::cout << c[t][j] << "\t";
	std::cout << std::endl;
      }
    }
  }
  return 0;
}
