/*
  superabundants.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <libgen.h>
#include <boost/lexical_cast.hpp>
#include "prime_util.hh"

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [-u upper]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  isprime_bit_table_class::huge_uint_type n, u(1000000), m(0), s, o(1);

  for (a=1; a<argc; ++a)
    if (std::string(argv[a]) == "-h")
      return usage(std::cerr, argc, argv);
    else if (std::string(argv[a]) == "-u" && a+1 < argc)
      u = boost::lexical_cast<isprime_bit_table_class::huge_uint_type>(argv[++a]);
    else
      break;
  
  isprime_bit_table_class isprime_bit_table(u);
  for (n = 1; n < 3 && n < u; ++n)
    if ((s=sum_divisors(n))*o > m*n) {
      std::cout << n << std::endl;
      m = s;
      o = n;
    }
  for (; n < u; n = isprime_bit_table.nextcomposite(n))
    if ((s=sum_divisors(n))*o > m*n) {
      std::cout << n << std::endl;
      m = s;
      o = n;
    }

  return 0;
}
